;toString routine
;In: real variable x hold value
;Out: string variable STR holds the converted string

;    Copyright (C) 2004  Steven Zhang
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA


#include "ti86asm.inc"
.org _asm_exec_ram
Start:
    ld hl,Name-1                ;ld hl with "STR" as variable name
    rst 20h                     ;call _mov10toop1
    rst 10h                     ;call _findSym
    call nc,_delvar             ;if exists delete
    call _rclX                  ;ld OP1 with value of x
    ld a,$12                    ;ld a with max length of string
    call _formReal              ;format real into string OP3-OP4
    push bc                     ;save bc (length of string)
    ld hl,_op3                  ;ld hl with address of OP3(the create string routine destroy op4,op2,op1 and others)
    ld de,Temp+8                ;ld de with 8 bytes past the end of the program
    ldir                        ;block copy
    pop de                      ;save the string length in DE
    ld a,3                      ;ld a with length of name
    ld hl,Name+1                ;ld hl with "STR"
    ld bc,Temp+8                ;ld bc with the address of start of data
    
;==========================================================
; Create String routine
; by Andreas Finne <a_finne@hotmail.com>
; date: 10 Dec 1999
;
; Size: 40 bytes
;
; Input:
; de = length of data
; a  = length of name <=8
; hl = pointer to filename
; bc = pointer to start of data (Must be on ram page 0 or 1)
;==========================================================

CreateString:
    push bc                     ;Save the pointer to start of data
    push de                     ;Save the length of data twice
    push de
    ld de,_OP1+1                ;Point de to OP1+1
    ld (de),a                   ;Load length of string name to OP1+1
    ld c,a                      ;
    xor a                       ;Load length of string name to bc
    ld b,a                      ;
    inc de                      ;de = OP1+2
    ldir                        ;Copy the name into OP1+2->
    pop hl                      ;hl = length of data
    call _createstrng           ;create a string with namelength=OP1+1, name=OP1+2->, hl=number of bytes
    ld a,b                      ;_createstrng returns the ABS address of the created string to bde
    ex de,hl                    ;bde to ahl
    call _ahl_plus_2_pg3        ;Skip size bytes of the string (ahl=ahl+2)
    call _set_abs_dest_addr     ;Set destination address of _mm_ldir to ahl
    pop hl                      ;hl = length of data
    xor a                       ;a=0
    call _set_mm_num_bytes      ;Number of bytes to copy = ahl
    pop hl                      ;hl = pointer to start of data
    call _set_abs_src_addr      ;Set source address of _mm_ldir to ahl
    call _mm_ldir               ;Copy _mm_num_bytes from _abs_src_addr to _abs_dest_addr
    jp _ram_page_1              ;_mm_ldir changes ram pages, this loads page #1 and returns

Name:
    .db 3,"STR"                 ;length indexed string name
Temp:                           ;safe temp storage area after the program